namespace AddisonWesley.Michaelis.EssentialCSharp.Chapter19.Listing19_07
{
    using System;
    using System.Threading.Tasks;

    public class Program
    {
        public static void Main()
        {
            // Aby zastosować bibliotekę TPL w wersjach starszych niż .NET 4.5, 
            // wywołaj metodę Task.Factory.StartNew<string>().
            Task task = Task.Run(() =>
            {
                throw new InvalidOperationException();
            });

            try
            {
                task.Wait();
            }
            catch(AggregateException exception)
            {
                exception.Handle(eachException =>
                {
                    Console.WriteLine(
                        $"BŁĄD: { eachException.Message }");
                    return true;
                });
            }
        }
    }
}
